
clear
set more off
infile using H98PR_MC.dct
gen HHIDSUB=HHID+"-"+FSUBHH

gen HHIDSUBFAM=HHID+"-"+FSUBHH+"-"+FPN_FAM

gen HHIDSUBOPN=HHID+"-"+FSUBHH+"-"+OPN
sort HHIDSUBOPN
save H98PR_MC.dta, replace
*
clear
set more off
infile using H98D_H.dct
gen HHIDSUB=HHID+"-"+FSUBHH

gen HHIDSUBFAM=HHID+"-"+FSUBHH+"-"+FPN_FAM

sort HHIDSUBFAM
save H98D_H.dta, replace

* which grandkids from parents' info
use H98D_H.dta, clear

keep HHIDSUBFAM HHID FSUBHH F1775* F1776*

reshape long F1775_ F1776_ , i(HHIDSUBFAM)
rename F1775 OPN
rename F1776 newgkkid
gen HHIDSUBOPN=HHID+"-"+FSUBHH+"-"+OPN
drop if OPN==""
sort HHIDSUBOPN
save newgk98.dta, replace

* add info from 1996
clear
infile using H96D_MC.dct

gen HHIDSUB=HHID+"-"+ESUBHH
gen HHIDSUBFAM=HHID+"-"+ESUBHH+"-"+EPN_FAM

gen HHIDSUBOPN=HHID+"-"+ESUBHH+"-"+OPN
sort HHIDSUBOPN
save H96D_MC.dta, replace

*add info from 2000 (mainly for AHEAD)
clear
infile using H00D_MC.dct

gen HHIDSUB=HHID+"-"+GSUBHH

gen HHIDSUBFAM=HHID+"-"+GSUBHH+"-"+GPN_FAM

gen HHIDSUBOPN=HHID+"-"+GSUBHH+"-"+OPN
sort HHIDSUBOPN
save H00D_MC.dta, replace

* create ID for region
use HRSREGION.dta 
drop HHIDSUBPN
gen HHIDSUBPN=HHID+"-"+FSUBHH+"-"+PN
sort HHIDSUBPN
save  HRSREGION98_PN.dta, replace


* PREPARE PARENTS' DATA
clear all
set mem 900m
set maxvar 10000
use h98f2b.dta, clear
*make string
tostring hhidpn, gen(temp)
replace temp="00000"+temp if length(temp)==4
replace temp="0"+temp if length(temp)==8
gen HHID=substr(temp,1,6)
gen PN=substr(temp,-3,3)
gen HHIDSUB=HHID+"-"+fsubhh
gen HHIDSUBPN=HHID+"-"+fsubhh+"-"+PN
order HHID* PN

* demo
gen age=1998-birthyr
rename gender GENDER
rename race RACE
rename f809 FA099 
rename f811 FA100
rename f816 FA101 
rename f3115m1 FJ005M1 
rename hispanic HISPANIC 
rename f300 USBORN 

gen married=f1071==1
gen sepdiv=f1071==3 | f1071==4
gen widowed=f1071==5
gen nevermarried=f1071==6
gen othermarstat=f1071==0 | f1071==7 
rename f1071 maritalstat

* ADL with helpers info
foreach var of varlist  f2425 f2427 f2444 f2454 f2464 f2477 {
gen t`var'=`var'==1 |`var'==6
}
egen ADLsum=rowtotal(tf*) 
drop tf*
label var ADLsum "#ADL difficulties/cant do (max 6)"


* some more ADL 
foreach var of varlist f2391 f2394 f2397 f2400 f2403 f2406 f2409 f2415 f2418 f2421 {
gen t`var'=`var'==1 |`var'==6 
}
egen ADLsum2=rowtotal(tf*) 
drop tf*
label var ADLsum2 "# SOME MORE ADL difficulties (max 10)"

gen ADLall= ADLsum + ADLsum2

 
*  IADL 
foreach var of varlist f2562 f2567 f2572 f2577  {
gen t`var'=`var'==1 |`var'==6 
}
egen IADLsum=rowtotal(tf*) 
drop tf*
label var IADLsum "#IADL difficulties/cant do (max 4), except money"

gen IADLmoney= f2618==1 | f2618==6

label var IADLmoney "IADL managing money diffciulties/cant do"

recode f987a (.=99)

gen LTHighSchool=f987a<=11  
gen HighSchool=f987a==12
gen SomeCollege=f987a>=13 & f987a<=15
gen College=f987a==16
gen PostCollege=f987a==17
gen EducMissing=f987a>=96

gen religion_very=f1055==1
gen religion_some=f1055==3

recode f1097 (8/9=5), gen(sah)


gen highbp=f1109==1
gen diabetes = f1116==1
gen cancer = f1129==1 | f1134==1
gen lung=f1146==1
*/ include heart condition, heart attack, angina and congestive failure */
gen heart=f1156==1 | f1162==1 | f1168==1| f1171==1 
gen stroke = f1176==1
* no depression, alzheimers, and dementia
gen mental= f1189==1
gen memory= f1193==1
gen arthritis=f1194==1
* no shingles
gen brokenhip=f1215==1
gen incontinence=f1220==1
gen hearing_wefair=f1236>=4
gen eye_wefair= f1228>=4
recode f1207 (.=0) (98=.), gen(nm_fallen)


gen NURSEHOME=fnhm==1
gen Hownhouse=f2743==1

sort HHIDSUBPN
merge HHIDSUBPN using HRSREGION98_PN.dta , keep(Region98 UrbRur98)
tab _merge
drop if _merge==2
drop _merge

recode UrbRur98 (.=9), gen(metro)
qui tab metro, gen(metro)
label var metro1 "metro 1mil /more pop"
label var metro2 "metro 250k-1mil pop"
label var metro3 "metro <250k pop"
label var metro4 "metro missing"

drop temp
tostring ffam_rhp, gen(temp)
gen FPN_FAM=substr(temp,-3,.)
drop temp
tostring fphhidpn, gen(temp)
gen FPN_SP=substr(temp,-3,.)
drop temp

gen DR=FPN_FAM 
replace DR=PN if FPN_FAM==""
gen R=1 if DR==PN
destring FPN_SP, gen(sp_id)
drop pn
destring PN, gen(pn)

gen S_id=.
foreach j of numlist 10/12 20/21 30/32 40/41   {
gen tem`j'=sp_id if pn==`j'
egen temr=max(tem`j'), by(HHIDSUB)
replace S_id=temr if sp_id ==`j'
drop tem`j' temr
}
gen S=1 if pn==S_id & S_id!=. & R==.

egen R_age=max(age*R), by(HHIDSUB) 
egen S_age=max(S*age), by(HHIDSUB)  
order HHIDSUB S R DR age R_age S_age

recode study (11=12)
label define study 12"AHEAD" 21"CODA" 1"HRS" 31"WAR"
label values study study

global xvar "FA099 FA100 FA101  married- nm_fallen FJ005M1 HISPANIC USBORN"
global cvar "GENDER RACE study"
global dvar "NURSEHOME*"
foreach var of varlist pn $xvar $cvar $dvar {
egen R_`var'=max(`var'*R), by(HHIDSUB) 
egen S_`var'=max(S*`var'), by(HHIDSUB)  
 }

drop S_id

bysort HHIDSUB: gen index=_n
tab index
keep if index==1

keep HHIDSUB R_* S_* metro* Hownhouse 
 
order HHID  metro* Hownhouse R_* S_*
sort HHIDSUB
  
save parent_long98.dta, replace

 
clear
infile using H98D_MC.dct

gen HHIDSUB=HHID+"-"+FSUBHH

gen HHIDSUBFAM=HHID+"-"+FSUBHH+"-"+FPN_FAM

gen HHIDSUBOPN=HHID+"-"+FSUBHH+"-"+OPN


sort HHIDSUBOPN
merge HHIDSUBOPN using H98PR_MC.dta
tab _merge /* checked all 3*/
drop if _merge==2
drop _merge

bysort HHIDSUB OPN: gen index=_n
tab index /* checked all 1*/
keep if index==1 
drop index

sort HHIDSUB
merge HHIDSUB using H98D_H.dta
tab _merge
drop if _merge==2
drop _merge

* select child or step/partner child
keep if F1761==1  | F1761==2 | F11A==1 | F11A==2 

* NOT IN LAW
gen C_GENDER= F10
gen C_bioson= (F1761==1| F11A==1) & F10==1 
gen C_stepson= (F1761==2| F11A==2) & F10==1 
gen C_biodgt= (F1761==1| F11A==1) & F10==2 
gen C_stepdgt= (F1761==2| F11A==2) & F10==2

*died
drop if F7==4
order HHID* OPN FSUBHH FPN_* C_bio* C_step* C_* 

gen C_cores= F7>=1 & F7<=3 | F148>=1  & F148<=3
replace C_cores=. if F7>=7
replace C_cores=1 if F1726==F1732
replace C_cores=1 if F1728==0 & F1732>=1

foreach var of varlist F1765M* {
tostring `var', replace
replace `var'="0"+`var' if length(`var')==2
gen t`var'= `var'==OPN
replace t`var'=1 if `var'=="038"
}
egen C_near10=rowtotal(tF*)
replace C_near10=1 if C_near10>=1
drop tF*
egen count=count(1), by(HHIDSUB)
replace C_near10=1 if count==1 & F1764==1
replace C_near10=0 if C_cores==1

gen C_partner = F13<=3

gen C_age =1998-F16 if F16<9000 
replace C_age=. if C_age>200

sort HHIDSUBOPN
merge HHIDSUBOPN using H96D_MC.dta, keep(E1392)
tab _merge
drop if _merge==2
drop _merge
sort HHIDSUBOPN
merge HHIDSUBOPN using newgk98.dta, keep(newgkkid)
tab _merge
drop if _merge==2
drop _merge
sort HHIDSUBOPN
merge HHIDSUBOPN using H00D_MC.dta, keep(G2030)
tab _merge
drop if _merge==2
drop _merge
 

gen C_kids=F1814 
replace C_kids=newgkkid if new!=. & C_kids==.
replace C_kids=E1392 if C_kids==.
replace C_kids=G2030 if C_kids==.
label var C_kids "# kids of child"

* children educ has many missing
gen C_educ=F1792

* many missing educ--- get from 2000 data
sort HHIDSUBOPN
merge HHIDSUBOPN using childeduc00.dta, keep(G2008)
tab _merge
drop if _merge==2
drop _merge

replace C_educ=G2008 if C_educ==.
recode C_educ (.=99)

gen C_LTHighSchool=C_educ<=11 
gen C_HighSchool=C_educ==12
gen C_SomeCollege=C_educ>=13 & C_educ<=15
gen C_College=C_educ==16
gen C_PostCollege=C_educ==17
gen C_EducMiss=C_educ>=96

keep C_*  HHID* FPN_* FSUB OPN 

sort HHIDSUB
merge HHIDSUB using parent_long98.dta
tab _merge
drop if _merge==2
drop _merge 

save childdata_all98.dta, replace


use childdata_all98.dta, replace
* Choose population (
disp in red _N
* missing C_age and C_gender
egen maxc=max(C_age==.), by(HHIDSUB)
egen minc=max(C_GENDER==.), by(HHIDSUB)
drop if maxc==1 | minc==1
drop maxc minc 
disp in red _N
* No too young or too old children
egen maxc=max(C_age), by(HHIDSUB)
egen minc=min(C_age), by(HHIDSUB)
gen C_agegaptoE=maxc-C_age
gen C_agegaptoY=C_age-minc
*drop if maxc>65| minc<35
drop if max>65 | minc<20
drop maxc minc 
disp in red _N
* missing P_age
egen maxc=max(R_age==.), by(HHIDSUB)
drop if maxc==1 
drop maxc 
disp in red _N
* Min Spouse and R's age is 50
gen SINGLE= S_age==.
gen minc=min(R_age,S_age) if SINGLE==0
drop if minc<50 & SINGLE==0
drop if R_age<50
disp in red _N 
drop minc
* drop if in NH
gen nh1998=R_NURSEHOME==1
replace nh1998=1 if S_NURSEHOME==1
egen maxc=max(nh1998), by(HHIDSUB)
drop if maxc==1 
drop maxc nh1998
disp in red _N
* max child age < min parent age-15
egen maxc=max(C_age), by(HHIDSUB)
gen minc=max(R_age,S_age) if SINGLE==0
replace minc=R_age if SINGLE==1
gen t=minc-maxc
keep if t>15
drop maxc minc t
disp in red _N
* no step children
egen maxc=max(C_stepson+ C_stepdgt), by(HHIDSUB)
drop if maxc==1
drop maxc
disp in red _N
* no same age
bysort HHIDSUB -C_age: gen indage= _n
egen multipleage=max(indage), by(HHIDSUB)
tab multiple
drop if multiple>1
drop multiple
disp in red _N
* LESS THAN 5 CHILDREN
egen TOTCHILD=sum(1), by(HHIDSUB)
keep if TOT<=4
disp in red _N

egen tmax=max(C_age), by(HHIDSUB)
gen C_eldest=tmax==C_age 
egen tmin=min(C_age) , by(HHIDSUB)
gen C_youngest=tmin==C_age 
gen C_onlychild=tmin==tmax & tmin>0 & tmin!=.
drop tmin tmax
replace C_eldest=0 if C_only==1
replace C_youngest=0 if C_only==1

egen count=count(1), by(HHIDSUB)
tab C_only count
replace C_only=0 if count>1


label var C_partner "Child married or partnered"
label var C_eldest "Eldest child in multi child; 0 if one child"
label var C_youngest "Youngest child in multi child; 0 if one child"
label var C_only "Only child (eldest=youngest=0)"

* logit dep var
gen Y=0 
replace Y=1 if C_near10==1 | C_cores==1
label def Y 0"Far" 1"Near/Cores" 
label values Y Y

* GENERATING VARIABLES 

recode C_GENDER (2=0), gen(C_male)
label var C_male "C_male"

recode C_partner (5=0)
label var C_partner "C_spouse"
gen C_kids_missing=C_kids>90 
replace C_kids_m=1 if C_kids==.
recode C_kids (98/99=0) (.=0)

* sibling structure
gen dage1=0
gen dage2=0
gen dage3=0
gen dage4=0
gen dsex1=0
gen dsex2=0
gen dsex3=0
gen dsex4=0

gsort HHIDSUB -C_age
by HHIDSUB : gen bo=_n
forvalues i=1(1)4 {
gen temp=C_age if bo==`i'
gen temp2=C_male if bo==`i'
egen maxc`i'=max(temp), by(HHIDSUB)
egen sexd`i'=max(temp2), by(HHIDSUB)
replace dage`i'=abs(maxc`i'-C_age)
replace dsex`i'=abs(sexd`i'-C_male)
drop temp*
}

replace dage1=0 if dage1==.
replace dage2=0 if dage2==.
replace dage3=0 if dage3==.
replace dage4=0 if dage4==.
replace dsex1=0 if dsex1==.
replace dsex2=0 if dsex2==.
replace dsex3=0 if dsex3==.
replace dsex4=0 if dsex4==.

gen C_hasyoungerB=0 
gen C_hasyoungerS=0 
 forvalues i=1(1)4 {
replace C_hasyoungerB=1 if maxc`i'<C_age & sexd`i'==1
replace C_hasyoungerS=1 if maxc`i'<C_age & sexd`i'==0
}

gen C_M_hasyounger=0
gen C_F_hasyounger=0
replace C_M_hasyounger=1 if C_male==1 & (C_hasyoungerB==1 | C_hasyoungerS==1)
replace C_F_hasyounger=1 if C_male==0 & (C_hasyoungerB==1 | C_hasyoungerS==1)

gen C_M_youngest=0
gen C_F_youngest=0

by HHIDSUB: replace C_M_youngest=1 if C_male==1 & _n==_N & TOTCHILD>1
by HHIDSUB: replace C_F_youngest=1 if C_male==0 & _n==_N & TOTCHILD>1

gen C_kids_partner=C_kids* C_partner
gen C_kids_single=C_kids*(1-C_partner)

gen C_male_partner=C_male*C_partner
gen C_male_single=C_male*(1-C_partner)
gen C_female_partner=(1-C_male)*C_partner
gen C_female_single = C_male==0 & C_female_partner==0

gen C_age3039= C_age>=30 & C_age<40
gen C_age4049= C_age>=40 & C_age<50
gen C_age50p= C_age>=50

* PARENT VARIABLES
gen P_father=SINGLE==1 & R_GENDER==1
gen P_mother=SINGLE==1 & R_GENDER==2

* parent's age diff
gen P_age = R_age
replace P_age=(R_age+S_age)/2 if SINGLE==0
replace P_age=round(P_age)

gen P_age5064=P_age<=64
gen P_age6579=P_age>=65 & P_age<=79
gen P_age80p=P_age>=80

* both parents beliefs on importance of religion
gen P_religion_very= R_religion_very==1 & SINGLE==1
replace P_religion_very= 1 if R_religion_very==1 & S_religion_very==1 & SINGLE==0

* both parents born in the US
gen P_FOREIGN_BOTH=0
replace P_FOREIGN=1 if R_USBORN!=1 & S_USBORN!=1 & SINGLE==0
replace P_FOREIGN=1 if R_USBORN!=1 & SINGLE==1

* both parents BLACK OR OTHERS
gen P_WHITE_BOTH= R_RACE==1 & S_RACE==1
replace P_WHITE_BOTH=1 if R_RACE==1 & SINGLE==1


* parent health information 
factor R_sah R_ADLall R_IADLsum R_diabetes R_highbp R_stroke
predict R_health

factor S_sah S_ADLall S_IADLsum S_diabetes S_highbp S_stroke if P_father==0 & P_mother==0
predict S_health

gen P_health = -R_health
replace P_health = -(R_health+S_health)/2 if P_father==0 & P_mother==0

* education: ref: at least one parent has High school the other is lower or missing or both missing
gen P_LTHighSchool_both=0
replace P_LTHighSchool_both= R_LTHighSchool if SINGLE==1
replace P_LTHighSchool_both=1 if R_LTHighSchool==1 & S_LTHighSchool==1 & SINGLE==0

gen R_CollegeP=R_College+ R_PostCollege
gen S_CollegeP=S_College+ S_PostCollege

gen P_CollegeP_anyone=0
replace P_CollegeP_anyone= R_CollegeP if SINGLE==1
replace P_CollegeP_anyone=1 if R_CollegeP==1 & S_CollegeP==0 & SINGLE==0
replace P_CollegeP_anyone=1 if R_CollegeP==1 & S_CollegeP==1 & SINGLE==0
replace P_CollegeP_anyone=1 if R_CollegeP==0 & S_CollegeP==1 & SINGLE==0
drop R_CollegeP S_CollegeP

gen S_lower=1 if (SINGLE==0 & S_HighSchool==1) |(SINGLE==0 & S_LTHighSchool==1)
gen R_lower=1 if (SINGLE==0 & R_HighSchool==1) |(SINGLE==0 & R_LTHighSchool==1) | (SINGLE==0 & R_EducMissing==1)
gen P_SomeCollege_anyone=0
replace P_SomeCollege_anyone=R_SomeCollege if SINGLE==1
replace P_SomeCollege_anyone=1 if R_SomeCollege==1 & S_lower==1 & SINGLE==0
replace P_SomeCollege_anyone=1 if R_lower==1 & S_SomeCollege==1 & SINGLE==0
replace P_SomeCollege_anyone=1 if R_SomeCollege==1 & S_SomeCollege==1 & SINGLE==0
drop *_lower

gen R_tempeduc=R_HighSchool + R_EducMi
gen S_tempeduc=S_HighSchool + S_EducMi

gen P_HighSchool_anyone=0
replace P_HighSchool_anyone=R_tempeduc if SINGLE==1
replace P_HighSchool_anyone=1 if R_tempeduc==1 & S_LTHighSchool==1 & SINGLE==0
replace P_HighSchool_anyone=1 if R_LTHighSchool==1 & S_tempeduc==1 & SINGLE==0
replace P_HighSchool_anyone=1 if R_tempeduc==1 & S_tempeduc==1 & SINGLE==0
replace P_HighSchool_anyone=0 if P_SomeCollege
drop *tempeduc

bysort HHIDSUB: gen index=_n

tab TOTCHILD if index==1
gen C_nearcores=0
replace C_nearcores=1 if C_cores==1 | C_near10==1
gen C_far=1-C_nearcores

egen H_near=sum(C_nearcores), by(HHIDSUB)
egen H_far=sum(C_far), by(HHIDSUB)
egen H_neary=sum(C_nearcores*C_youngest), by(HHIDSUB)
egen H_neare=sum(C_nearcores*C_eldest), by(HHIDSUB)

bysort TOT: tab  H_far H_near if index==1
tab  H_neare H_neary if index==1 & TOT==2

qui tab R_study, gen(P_cohort)
label var P_cohort1 "HRS"
label var P_cohort2 "AHEAD"
label var P_cohort3 "CODA"
label var P_cohort4 "WAR"

save childdata_population98.dta, replace
