
clear
set more off
use H04PR_MC.dta
gen HHIDSUB=HHID+"-"+JSUBHH

gen HHIDSUBFAM=HHID+"-"+JSUBHH+"-"+JPN_FAM

gen HHIDSUBOPN=HHID+"-"+JSUBHH+"-"+OPN
sort HHIDSUBOPN
save H04PR_MC.dta, replace
*
clear
set more off
infile using H04E_H.dct
gen HHIDSUB=HHID+"-"+JSUBHH

gen HHIDSUBFAM=HHID+"-"+JSUBHH+"-"+JPN_FAM

sort HHIDSUBFAM
save H04E_H.dta, replace
*
* create ID for region
use HRSREGION.dta , clear
drop HHIDSUBPN
gen HHIDSUBPN=HHID+"-"+JSUBHH+"-"+PN
sort HHIDSUBPN
save  HRSREGION04_PN.dta, replace



* PREPARE PARENTS' DATA
clear all
set mem 900m
set maxvar 10000
use h04f1a.dta, clear
*make string
tostring hhidpn, gen(temp)
replace temp="00000"+temp if length(temp)==4
replace temp="0"+temp if length(temp)==8
gen HHID=substr(temp,1,6)
gen PN=substr(temp,-3,3)
gen HHIDSUB=HHID+"-"+jsubhha_r
gen HHIDSUBPN=HHID+"-"+jsubhha_r+"-"+PN
order HHID* PN

* demo
gen age=2004-birthyr
rename gender GENDER
rename race RACE
rename ja099 JA099 
rename ja100 JA100
rename ja101 JA101 
rename jj005m1 JJ005M1 
rename hispanic HISPANIC 
rename usborn USBORN 

gen married=jb063==1
gen sepdiv=jb063==3 | jb063==4
gen widowed=jb063==5
gen nevermarried=jb063==6
gen othermarstat=jb063==2 | jb063==7 
rename jb063 maritalstat

* ADL with helpers info
foreach var of varlist  jg014  jg016 jg021 jg023 jg025 jg030 {
gen t`var'=`var'==1 |`var'==6
}
egen ADLsum=rowtotal(tjg*) 
drop tjg*
label var ADLsum "#ADL difficulties/cant do (max 6)"


* some more ADL 
foreach var of varlist jg001 jg003 jg004 jg005 jg007 jg008 jg009 jg010 jg011 jg012 {
gen t`var'=`var'==1 |`var'==6 
}
egen ADLsum2=rowtotal(tjg*) 
drop tjg*
label var ADLsum2 "# SOME MORE ADL difficulties (max 10)"

gen ADLall= ADLsum + ADLsum2

*  IADL 
foreach var of varlist jg041 jg044 jg047 jg050 {
gen t`var'=`var'==1 |`var'==6 
}
egen IADLsum=rowtotal(tjg*) 
drop tjg*
label var IADLsum "#IADL difficulties/cant do (max 4), except money"

gen IADLmoney= jg059==1 | jg059==6
label var IADLmoney "IADL managing money diffciulties/cant do"

gen LTHighSchool=jb014a<=11  
gen HighSchool=jb014a==12
gen SomeCollege=jb014a>=13 & jb014a<=15
gen College=jb014a==16
gen PostCollege=jb014a==17
gen EducMissing=jb014a>=96

gen religion_very=jb053==1
gen religion_some=jb053==3

recode jc001 (8/9=5), gen(sah)

gen highbp=jc005==1
gen diabetes = jc010==1
gen cancer = jc018==1 | jc024==1
gen lung=jc030==1
*/ include all heart problems */
gen heart=jc036==1 | jc040==1 | jc045==1 | jc048==1 
gen stroke = jc053==1
* no depression, alzheimers, and dementia
gen mental= jc065==1
gen memory=jc069==1
gen arthritis=jc070==1
* no shingles
gen brokenhip=jc082==1
gen incontinence=jc087==1
gen hearing_wefair=jc103>=4
gen eye_wefair= jc095>=4

recode jc080 (.=0) (98=.), gen(nm_fallen)

gen NURSEHOME=jnurshm==1
gen Hownhouse=jh004==1

sort HHIDSUBPN
merge HHIDSUBPN using HRSREGION04_PN.dta , keep(Region04 UrbRur04)
tab _merge
drop if _merge==2
drop _merge

recode UrbRur04 (.=9), gen(metro)
qui tab metro, gen(metro)
label var metro1 "metro 1mil /more pop"
label var metro2 "metro 250k-1mil pop"
label var metro3 "metro <250k pop"
label var metro4 "metro missing"

drop temp
tostring jfam_rhp, gen(temp)
gen JPN_FAM=substr(temp,-3,.)
drop temp
tostring jphhidpn, gen(temp)
gen JPN_SP=substr(temp,-3,.)
drop temp

gen DR=JPN_FAM 
replace DR=PN if JPN_FAM==""
gen R=1 if DR==PN
destring JPN_SP, gen(sp_id)
drop pn
destring PN, gen(pn)

gen S_id=.
foreach j of numlist 10/13 20/22 30/32 40/42 811 821 831 841  {
gen tem`j'=sp_id if pn==`j'
egen temr=max(tem`j'), by(HHIDSUB)
replace S_id=temr if sp_id ==`j'
drop tem`j' temr
}
gen S=1 if pn==S_id & S_id!=. & R==.

egen R_age=max(age*R), by(HHIDSUB) 
egen S_age=max(S*age), by(HHIDSUB)  
order HHIDSUB S R DR age R_age S_age


recode study (11=12)
label define study 12"AHEAD" 21"CODA" 1"HRS" 31"WAR"
label values study study


global xvar "JA099 JA100 JA101 married-nm_fallen JJ005M1 HISPANIC USBORN"
global cvar "GENDER RACE study"
global dvar "NURSEHOME*"
foreach var of varlist pn $xvar $cvar $dvar {
egen R_`var'=max(`var'*R), by(HHIDSUB) 
egen S_`var'=max(S*`var'), by(HHIDSUB)  
 }

drop S_id

bysort HHIDSUB: gen index=_n
tab index
keep if index==1

keep HHIDSUB R_* S_* metro* Hownhouse 
 
order HHID  metro* Hownhouse  R_* S_*
sort HHIDSUB
  
save parent_long04.dta, replace

 
clear
infile using H04E_MC.dct

gen HHIDSUB=HHID+"-"+JSUBHH

gen HHIDSUBFAM=HHID+"-"+JSUBHH+"-"+JPN_FAM

gen HHIDSUBOPN=HHID+"-"+JSUBHH+"-"+OPN
sort HHIDSUBOPN

merge HHIDSUBOPN using H04PR_MC.dta
tab _merge
* 2s: not in 2004 data but exist because there is no other info about them
*drop if _merge==2
rename _merge PR_merge

bysort HHIDSUB OPN: gen index=_n
tab index
keep if index==1 /* checked all 1*/
drop index

sort HHIDSUB
merge HHIDSUB using H04E_H.dta
tab _merge
drop if _merge==2
drop _merge

* select child or step/partner child
replace JX061_MC=JEX061 if JX061_MC==.

keep if JX061_MC>=3 & JX061_MC<=8  
drop if JX061_MC==5 | JX061_MC==8 

* NOT IN LAW
gen C_GENDER= JX060_MC
gen C_bioson= JX061_MC==3 
gen C_stepson= JX061_MC==4
gen C_biodgt= JX061_MC==6 
gen C_stepdgt= JX061_MC==7 

* died
drop if JX056_MC==4

order HHID* OPN JSUBHH JPN_* C_bio* C_step* 

gen C_cores= JX056_MC>=1 & JX056_MC<=3
replace C_cores=. if JX056_MC==.

foreach var of varlist JE013M* {
tostring `var', replace
replace `var'="0"+`var' if length(`var')==2
gen t`var'= `var'==OPN
replace t`var'=1 if `var'=="993"
}
egen C_near10=rowtotal(tJE*)
replace C_near10=1 if C_near10>=1
drop tJE*
egen count=count(1), by(HHIDSUB)
replace C_near10=1 if count==1 & JE012==1
replace C_near10=0 if C_cores==1

gen C_partner = JX065_MC<=3

gen C_age =JE027 if JE027<900 
replace C_age= 2004-JX067_MC if JE027==.
replace C_age=. if C_age>200

gen C_kids=JE044 
replace C_kids=JE025 if C_kids==.
label var C_kids "# kids of child"

* children educ has many missing
gen C_educ=JE029
rename JE029 JE029_o

* childeduc
sort  HHIDSUBOPN
merge HHIDSUBOPN using childeduc04.dta
tab _merge
drop if _merge==2
drop _merge

replace C_educ=HE029 if C_educ==.  /* 2002 info*/
replace C_educ=G2008 if C_educ==. /* 2000 info */
replace C_educ=F1792 if C_educ==. /* 1998 info */
recode C_educ (.=99)

gen C_LTHighSchool=C_educ<=11 
gen C_HighSchool=C_educ==12
gen C_SomeCollege=C_educ>=13 & C_educ<=15
gen C_College=C_educ==16
gen C_PostCollege=C_educ==17
gen C_EducMiss=C_educ>=96

keep C_*  HHID* JPN_* JSUB OPN 

sort HHIDSUB
merge HHIDSUB using parent_long04.dta
tab _merge
drop if _merge==2
drop _merge 

save childdata_all04.dta, replace


use childdata_all04.dta, clear
* Choose population (
disp in red _N
* missing C_age and C_gender
egen maxc=max(C_age==.), by(HHIDSUB)
egen minc=max(C_GENDER==.), by(HHIDSUB)
drop if maxc==1 | minc==1
drop maxc minc 
disp in red _N
* No too young or too old children
egen maxc=max(C_age), by(HHIDSUB)
egen minc=min(C_age), by(HHIDSUB)
gen C_agegaptoE=maxc-C_age
gen C_agegaptoY=C_age-minc
*drop if maxc>65| minc<35
drop if maxc>65 | minc<20
drop maxc minc 
disp in red _N
* missing P_age
egen maxc=max(R_age==.), by(HHIDSUB)
drop if maxc==1 
drop maxc 
disp in red _N
* Min Spouse and R's age is 50
gen SINGLE= S_age==.
gen minc=min(R_age,S_age) if SINGLE==0
drop if minc<50 & SINGLE==0
drop if R_age<50
disp in red _N 
drop minc
* drop if in NH
gen nh2004=R_NURSEHOME==1
replace nh2004=1 if S_NURSEHOME==1
egen maxc=max(nh2004), by(HHIDSUB)
drop if maxc==1 
drop maxc nh2004
disp in red _N
* max child age < min parent age-15
egen maxc=max(C_age), by(HHIDSUB)
gen minc=max(R_age,S_age) if SINGLE==0
replace minc=R_age if SINGLE==1
gen t=minc-maxc
keep if t>15
drop maxc minc t
disp in red _N
* no step children
egen maxc=max(C_stepson+ C_stepdgt), by(HHIDSUB)
drop if maxc==1
drop maxc
disp in red _N
* no same age
bysort HHIDSUB -C_age: gen indage= _n
egen multipleage=max(indage), by(HHIDSUB)
tab multiple
drop if multiple>1
drop multiple
disp in red _N
* LESS THAN 5 CHILDREN
egen TOTCHILD=sum(1), by(HHIDSUB)
keep if TOT<=4
disp in red _N


egen tmax=max(C_age), by(HHIDSUB)
gen C_eldest=tmax==C_age 
egen tmin=min(C_age) , by(HHIDSUB)
gen C_youngest=tmin==C_age 
gen C_onlychild=tmin==tmax & tmin>0 & tmin!=.
drop tmin tmax
replace C_eldest=0 if C_only==1
replace C_youngest=0 if C_only==1

egen count=count(1), by(HHIDSUB)
replace C_only=0 if count>1

label var C_partner "Child married or partnered"
label var C_eldest "Eldest child in multi child; 0 if one child"
label var C_youngest "Youngest child in multi child; 0 if one child"
label var C_only "Only child (eldest=youngest=0)"

* logit dep var
gen Y=0 
replace Y=1 if C_near10==1 | C_cores==1
label def Y 0"Far" 1"Near/Cores" 
label values Y Y

* GENERATING VARIABLES 

recode C_GENDER (2=0), gen(C_male)
label var C_male "C_male"

recode C_partner (5=0)
label var C_partner "C_spouse"
gen C_kids_missing=C_kids>90
replace C_kids_m=1 if C_kids==.
recode C_kids (98/99=0) (.=0)

* sibling structure
gen dage1=0
gen dage2=0
gen dage3=0
gen dage4=0
gen dsex1=0
gen dsex2=0
gen dsex3=0
gen dsex4=0

gsort HHIDSUB -C_age
by HHIDSUB : gen bo=_n
forvalues i=1(1)4 {
gen temp=C_age if bo==`i'
gen temp2=C_male if bo==`i'
egen maxc`i'=max(temp), by(HHIDSUB)
egen sexd`i'=max(temp2), by(HHIDSUB)
replace dage`i'=abs(maxc`i'-C_age)
replace dsex`i'=abs(sexd`i'-C_male)
drop temp*
}

replace dage1=0 if dage1==.
replace dage2=0 if dage2==.
replace dage3=0 if dage3==.
replace dage4=0 if dage4==.
replace dsex1=0 if dsex1==.
replace dsex2=0 if dsex2==.
replace dsex3=0 if dsex3==.
replace dsex4=0 if dsex4==.

gen C_hasyoungerB=0 
gen C_hasyoungerS=0 
 forvalues i=1(1)4 {
replace C_hasyoungerB=1 if maxc`i'<C_age & sexd`i'==1
replace C_hasyoungerS=1 if maxc`i'<C_age & sexd`i'==0
}

gen C_M_hasyounger=0
gen C_F_hasyounger=0
replace C_M_hasyounger=1 if C_male==1 & (C_hasyoungerB==1 | C_hasyoungerS==1)
replace C_F_hasyounger=1 if C_male==0 & (C_hasyoungerB==1 | C_hasyoungerS==1)

gen C_M_youngest=0
gen C_F_youngest=0

by HHIDSUB: replace C_M_youngest=1 if C_male==1 & _n==_N & TOTCHILD>1
by HHIDSUB: replace C_F_youngest=1 if C_male==0 & _n==_N & TOTCHILD>1

gen C_kids_partner=C_kids* C_partner
gen C_kids_single=C_kids*(1-C_partner)

gen C_male_partner=C_male*C_partner
gen C_male_single=C_male*(1-C_partner)
gen C_female_partner=(1-C_male)*C_partner
gen C_female_single = C_male==0 & C_female_partner==0

gen C_age3039= C_age>=30 & C_age<40
gen C_age4049= C_age>=40 & C_age<50
gen C_age50p= C_age>=50

* PARENT VARIABLES
gen P_father=SINGLE==1 & R_GENDER==1
gen P_mother=SINGLE==1 & R_GENDER==2

* parent's age diff
gen P_age = R_age
replace P_age=(R_age+S_age)/2 if SINGLE==0
replace P_age=round(P_age)

gen P_age5064=P_age<=64
gen P_age6579=P_age>=65 & P_age<=79
gen P_age80p=P_age>=80

* both parents beliefs on importance of religion
gen P_religion_very= R_religion_very==1 & SINGLE==1
replace P_religion_very= 1 if R_religion_very==1 & S_religion_very==1 & SINGLE==0

* both parents born in the US
gen P_FOREIGN_BOTH=0
replace P_FOREIGN=1 if R_USBORN!=1 & S_USBORN!=1 & SINGLE==0
replace P_FOREIGN=1 if R_USBORN!=1 & SINGLE==1

* both parents BLACK OR OTHERS
gen P_WHITE_BOTH= R_RACE==1 & S_RACE==1
replace P_WHITE_BOTH=1 if R_RACE==1 & SINGLE==1


* parent health information 
factor R_sah R_ADLall R_IADLsum R_diabetes R_highbp R_stroke
predict R_health

factor S_sah S_ADLall S_IADLsum S_diabetes S_highbp S_stroke if P_father==0 & P_mother==0
predict S_health

gen P_health = -R_health
replace P_health = -(R_health+S_health)/2 if P_father==0 & P_mother==0

* education: ref: at least one parent has High school the other is lower or missing or both missing
gen P_LTHighSchool_both=0
replace P_LTHighSchool_both= R_LTHighSchool if SINGLE==1
replace P_LTHighSchool_both=1 if R_LTHighSchool==1 & S_LTHighSchool==1 & SINGLE==0

gen R_CollegeP=R_College+ R_PostCollege
gen S_CollegeP=S_College+ S_PostCollege

gen P_CollegeP_anyone=0
replace P_CollegeP_anyone= R_CollegeP if SINGLE==1
replace P_CollegeP_anyone=1 if R_CollegeP==1 & S_CollegeP==0 & SINGLE==0
replace P_CollegeP_anyone=1 if R_CollegeP==1 & S_CollegeP==1 & SINGLE==0
replace P_CollegeP_anyone=1 if R_CollegeP==0 & S_CollegeP==1 & SINGLE==0
drop R_CollegeP S_CollegeP


gen S_lower=1 if (SINGLE==0 & S_HighSchool==1) |(SINGLE==0 & S_LTHighSchool==1)
gen R_lower=1 if (SINGLE==0 & R_HighSchool==1) |(SINGLE==0 & R_LTHighSchool==1) | (SINGLE==0 & R_EducMissing==1)
gen P_SomeCollege_anyone=0
replace P_SomeCollege_anyone=R_SomeCollege if SINGLE==1
replace P_SomeCollege_anyone=1 if R_SomeCollege==1 & S_lower==1 & SINGLE==0
replace P_SomeCollege_anyone=1 if R_lower==1 & S_SomeCollege==1 & SINGLE==0
replace P_SomeCollege_anyone=1 if R_SomeCollege==1 & S_SomeCollege==1 & SINGLE==0
drop *_lower

gen R_tempeduc=R_HighSchool + R_EducMi
gen S_tempeduc=S_HighSchool + S_EducMi

gen P_HighSchool_anyone=0
replace P_HighSchool_anyone=R_tempeduc if SINGLE==1
replace P_HighSchool_anyone=1 if R_tempeduc==1 & S_LTHighSchool==1 & SINGLE==0
replace P_HighSchool_anyone=1 if R_LTHighSchool==1 & S_tempeduc==1 & SINGLE==0
replace P_HighSchool_anyone=1 if R_tempeduc==1 & S_tempeduc==1 & SINGLE==0
replace P_HighSchool_anyone=0 if P_SomeCollege
drop *tempeduc

bysort HHIDSUB: gen index=_n

tab TOTCHILD if index==1
gen C_nearcores=0
replace C_nearcores=1 if C_cores==1 | C_near10==1
gen C_far=1-C_nearcores

egen H_near=sum(C_nearcores), by(HHIDSUB)
egen H_far=sum(C_far), by(HHIDSUB)
egen H_neary=sum(C_nearcores*C_youngest), by(HHIDSUB)
egen H_neare=sum(C_nearcores*C_eldest), by(HHIDSUB)

bysort TOT: tab  H_far H_near if index==1
tab  H_neare H_neary if index==1 & TOT==2

qui tab R_study, gen(P_cohort)
label var P_cohort1 "HRS"
label var P_cohort2 "AHEAD"
label var P_cohort3 "CODA"
label var P_cohort4 "WAR"
label var P_cohort5 "Early BB"

save childdata_population04.dta, replace
