*
clear
set more off
infile using H10PR_MC.dct
gen HHIDSUB=HHID+"-"+MSUBHH

gen HHIDSUBFAM=HHID+"-"+MSUBHH+"-"+MPN_FAM

gen HHIDSUBOPN=HHID+"-"+MSUBHH+"-"+OPN
sort HHIDSUBOPN
save H10PR_MC.dta, replace
*

* informal care
clear
set more off
infile using H10G_HP.dct
gen HHIDSUB=HHID+"-"+MSUBHH
gen HHIDSUBOPN=HHID+"-"+MSUBHH+"-"+OPN
sort HHIDSUBOPN
save H10G_HP.dta, replace

*
clear
set more off
infile using H10E_H.dct
gen HHIDSUB=HHID+"-"+MSUBHH

gen HHIDSUBFAM=HHID+"-"+MSUBHH+"-"+MPN_FAM

sort HHIDSUBFAM
save H10E_H.dta, replace
*
* race from earlier wave
use h08f1b.dta, clear
*make string
tostring hhidpn, gen(temp)
replace temp="00000"+temp if length(temp)==4
replace temp="0"+temp if length(temp)==8
gen HHID=substr(temp,1,6)
gen PN=substr(temp,-3,3)
gen HHIDSUB=HHID+"-"+lsubhh
gen HHIDSUBPN=HHID+"-"+lsubhh+"-"+PN
order HHID* PN
rename race RACE08
sort  HHIDSUBPN
save h08f1b.dta, replace

use h10e1a.dta, clear
*make string
tostring hhidpn, gen(temp)
replace temp="00000"+temp if length(temp)==4
replace temp="0"+temp if length(temp)==8
gen HHID=substr(temp,1,6)
gen PN=substr(temp,-3,3)
gen HHIDSUB=HHID+"-"+msubhh
gen HHIDSUBPN=HHID+"-"+msubhh+"-"+PN
order HHID* PN
rename race RACE10_early
sort  HHIDSUBPN
save h10e1a.dta, replace

* PREPARE PARENTS' DATA (RAND version is only early release)
clear 
set more off
infile using H10A_R.dct
gen HHIDSUB=HHID+"-"+MSUBHH
gen HHIDSUBPN=HHID+"-"+MSUBHH+"-"+PN
order HHID* PN
sort HHIDSUBPN
save H10A_R.dta, replace

clear 
set more off
infile using H10B_R.dct
gen HHIDSUB=HHID+"-"+MSUBHH
gen HHIDSUBPN=HHID+"-"+MSUBHH+"-"+PN
order HHID* PN
sort HHIDSUBPN
save H10B_R.dta, replace

clear 
set more off
infile using H10C_R.dct
gen HHIDSUB=HHID+"-"+MSUBHH
gen HHIDSUBPN=HHID+"-"+MSUBHH+"-"+PN
order HHID* PN
sort HHIDSUBPN
save H10C_R.dta, replace

clear 
set more off
infile using H10F_R.dct
gen HHIDSUB=HHID+"-"+MSUBHH
gen HHIDSUBPN=HHID+"-"+MSUBHH+"-"+PN
order HHID* PN
sort HHIDSUBPN
save H10F_R.dta, replace

clear 
set more off
infile using H10J_R.dct
gen HHIDSUB=HHID+"-"+MSUBHH
gen HHIDSUBPN=HHID+"-"+MSUBHH+"-"+PN
order HHID* PN
sort HHIDSUBPN
save H10J_R.dta, replace

clear 
set more off
infile using H10G_R.dct
gen HHIDSUB=HHID+"-"+MSUBHH
gen HHIDSUBPN=HHID+"-"+MSUBHH+"-"+PN
order HHID* PN
sort HHIDSUBPN
save H10G_R.dta, replace

clear 
set more off
infile using H10PR_R.dct
gen HHIDSUB=HHID+"-"+MSUBHH
gen HHIDSUBPN=HHID+"-"+MSUBHH+"-"+PN
order HHID* PN
sort HHIDSUBPN
save H10PR_R.dta, replace

clear 
set more off
infile using H10H_H.dct
gen HHIDSUB=HHID+"-"+MSUBHH
order HHID*
sort HHIDSUB
save H10H_H.dta, replace

/* create ID for region
use HRSREGION.dta , clear
drop HHIDSUBPN
gen HHIDSUBPN2=HHID+"-"+LSUBHH+"-"+PN
sort HHIDSUBPN2
save HRSREGION10_PN.dta, replace


*++++++++++++++++++++++++++++++++++++++++++++++++++
* Merging data set 
use H10A_R.dta, clear
sort HHIDSUBPN
merge HHIDSUBPN using H10PR_R.dta
tab _merge
drop _merge
sort HHIDSUBPN
merge HHIDSUBPN using h10e1a.dta, keep(RACE10_early study)
tab _merge
drop if _merge==2
drop _merge
sort HHIDSUBPN
merge HHIDSUBPN using h08f1b.dta, keep(RACE08)
tab _merge
drop if _merge==2
drop _merge
sort HHIDSUBPN
merge HHIDSUBPN using H10B_R.dta
tab _merge
drop _merge
sort HHIDSUBPN
merge HHIDSUBPN using H10C_R.dta
tab _merge
drop _merge
sort HHIDSUBPN
merge HHIDSUBPN using H10F_R.dta
tab _merge
drop _merge
sort HHIDSUBPN
merge HHIDSUBPN using H10G_R.dta
tab _merge
drop _merge
sort HHIDSUBPN
merge HHIDSUBPN using H10J_R.dta
tab _merge
drop _merge
sort HHIDSUB
merge HHIDSUB using H10H_H.dta
tab _merge
drop _merge

* age
gen age=MA019
gen GENDER=MX060_R
gen white=RACE10_early 
replace white=MB028 if white==.
replace white=RACE08 if white==.
gen USBORN= MB002==1 | MZ230==1

gen married=MB063==1
gen sepdiv=MB063==3 | MB063==4
gen widowed=MB063==5
gen nevermarried=MB063==6
gen othermarstat=MB063==2 | MB063>=7 | MB063==. 
rename MB063 maritalstat

*  ADL 
foreach var of varlist MG014 MG016 MG021 MG023 MG025 MG030 {
gen t`var'=`var'==1
}
egen ADLsum=rowtotal(tMG*) 
drop tMG*
label var ADLsum "#ADL difficulties/cant do (max 6)"

* some more ADL (that are listed in 1998 data, only 10 minus jogging 1 mile, climbing stairs)
foreach var of varlist MG001 MG003 MG004 MG005 MG007 MG008 MG009 MG010 MG011 MG012 {
gen t`var'=`var'==1 |`var'==6
}
egen ADLsum2=rowtotal(tMG*) 
drop tMG*
label var ADLsum2 "# SOME MORE ADL difficulties (max 10)"

gen ADLall= ADLsum + ADLsum2

*  IADL 
foreach var of varlist  MG041 MG044 MG047 MG050 {
gen t`var'=`var'==1 |`var'==6
}
egen IADLsum=rowtotal(tMG*) 
drop tMG*
label var IADLsum "#IADL difficulties/cant do (max 4), except money"

gen IADLmoney= MG059==1 | MG059==6 
label var IADLmoney "IADL managing money diffciulties/cant do"


replace MB014=MZ216 if MB014==.

gen LTHighSchool=MB014<=11  
gen HighSchool=MB014==12
gen SomeCollege=MB014>=13 & MB014<=15
gen College=MB014==16
gen PostCollege=MB014==17
gen EducMissing=MB014>=96

gen religion_very=MB053==1
gen religion_some=MB053==3

recode MC001 (8/9=5), gen(sah)

gen highbp=MC005==1
gen diabetes = MC010==1
gen cancer = MC018==1 | MC024==1
gen lung=MC030==1
gen heart = MC036==1 |MC040==1 | MC260==1 |  MC263==1 /* include heart condition, heart attack, congestive heart failure (not incl before)) */
gen stroke = MC053==1
gen mental= MC065==1
gen depression=MC271==1
gen alzheimers=MC272==1
gen dementia=MC273==1
gen memory=depression==1 | alz==1 | dementia==1
drop depre alz demen
gen arthritis=MC070==1
gen brokenhip=MC082==1
gen incontinence=MC087==1
gen hearing_wefair=MC103>=4
gen eye_wefair= MC095>=4 

recode MC080 (.=0) (98=.), gen(nm_fallen)

gen NURSEHOME=MA028==1 
gen Hownhouse=MH004==1

* BASE ON 2008 location /* ABOUT 6000 NEW HH (no LSUBHH) has no region */
gen HHIDSUBPN2=HHID+"-"+LSUBHH+"-"+PN
sort HHIDSUBPN2
merge HHIDSUBPN2 using HRSREGION10_PN.dta , keep(Region08 UrbRur08)
tab _merge
drop if _merge==2
drop _merge HHIDSUBPN2

* BASE ON 2008 location /* ABOUT 6000 NEW HH (no LSUBHH) has no region */
replace UrbRur08=99 if LSUBHH==""
recode UrbRur08 (.=9), gen(metro)
qui tab metro, gen(metro)
label var metro1 "metro 1mil /more pop"
label var metro2 "metro 250k-1mil pop"
label var metro3 "metro <250k pop"
label var metro4 "metro missing"
rename metro5 metro5NewHH2010

gen DR=MPN_FAM
replace DR=PN if DR=="" 
gen R=1 if DR==PN
destring MPN_SP, gen(sp_id)
destring PN, gen(pn)

gen S_id=.
foreach j of numlist 10/13 20/23 30/32 40/43   {
gen tem`j'=sp_id if pn==`j'
egen temr=max(tem`j'), by(HHIDSUB)
replace S_id=temr if sp_id ==`j'
drop tem`j' temr
}
gen S=1 if pn==S_id & S_id!=. & R==.

egen R_age=max(age*R), by(HHIDSUB) 
egen S_age=max(S*age), by(HHIDSUB)  
order HHIDSUB S R DR age R_age S_age

recode study (11=12) (.=99)
label define study 12"AHEAD" 21"CODA" 1"HRS" 31"WAR" 41"Early BB" 99"LATE ADDITION"
label values study study

gen study2=study
replace study2=12 if study==99 & MX067_R<1924
replace study2=21 if study==99 & MX067_R>=1924 & MX067_R<=1930
replace study2=1 if study==99 & MX067_R>=1931 & MX067_R<=1941
replace study2=31 if study==99 & MX067_R>=1942 & MX067_R<=1947
replace study2=41 if study==99 & MX067_R>=1948 & MX067_R<=1953

tab study study2
drop study 
rename study2 study

global xvar "MA099 MA100 MA101 married-nm_fallen USBORN"
global cvar "GENDER white study"
global dvar "NURSEHOME*"
foreach var of varlist pn $xvar $cvar $dvar {
egen R_`var'=max(`var'*R), by(HHIDSUB) 
egen S_`var'=max(S*`var'), by(HHIDSUB)  
 }

drop S_id
bysort HHIDSUB: gen index=_n
tab index
keep if index==1

keep HHIDSUB R_* S_* metro* Hownhouse 
 
order HHID  metro* Hownhouse R_* S_*
sort HHIDSUB
  
save parent_long10.dta, replace

 
clear
infile using H10E_MC.dct

gen HHIDSUB=HHID+"-"+MSUBHH

gen HHIDSUBFAM=HHID+"-"+MSUBHH+"-"+MPN_FAM

gen HHIDSUBOPN=HHID+"-"+MSUBHH+"-"+OPN
sort HHIDSUBOPN

merge HHIDSUBOPN using H10PR_MC.dta
tab _merge
drop _merge

bysort HHIDSUB OPN: gen index=_n
tab index
egen maxc=max(index), by(HHIDSUB)
keep if maxc==1 
drop index maxc

sort HHIDSUB
merge HHIDSUB using H10E_H.dta
tab _merge
drop if _merge==2
drop _merge

* select child or step/partner child
replace MX061_MC=MEX061 if MX061_MC==.

keep if MX061_MC>=3 & MX061_MC<=8  
drop if MX061_MC==5 | MX061_MC==8 

* NOT IN LAW
gen C_GENDER= MX060_MC
gen C_bioson= MX061==3 
gen C_stepson= MX061==4
gen C_biodgt= MX061==6 
gen C_stepdgt= MX061==7 

* died
drop if MX056_MC==4

order HHID* OPN MSUBHH MPN_* C_bio* C_step* 

gen C_cores= MX056_MC>=1 & MX056_MC<=3
replace C_cores=. if MX056_MC==.

foreach var of varlist ME013M* {
tostring `var', replace
replace `var'="0"+`var' if length(`var')==2
gen t`var'= `var'==OPN
replace t`var'=1 if `var'=="993"
}
egen C_near10=rowtotal(tME*)
replace C_near10=1 if C_near10>=1
drop tME*
egen count=count(1), by(HHIDSUB)
replace C_near10=1 if count==1 & ME012==1
replace C_near10=0 if C_cores==1

gen C_partner = MX065_MC<=3

gen C_age =ME027 if ME027<900 
replace C_age= 2010-MX067_MC if ME027==.
replace C_age=. if C_age>200

gen C_kids=ME044 
replace C_kids=ME025 if C_kids==.
label var C_kids "# kids of child"

* children educ has many missing
gen C_educ=ME029
rename ME029 ME029_o

* childeduc
sort  HHIDSUBOPN
merge HHIDSUBOPN using childeduc10.dta
tab _merge
drop if _merge==2
drop _merge

replace C_educ=LE029 if C_educ==.  /* 2008 info*/
replace C_educ=KE029 if C_educ==.  /* 2006 info*/
replace C_educ=JE029 if C_educ==.  /* 2004 info*/
replace C_educ=HE029 if C_educ==.  /* 2002 info*/
replace C_educ=G2008 if C_educ==. /* 2000 info */
replace C_educ=F1792 if C_educ==. /* 1998 info */
recode C_educ (.=99)

gen C_LTHighSchool=C_educ<=11 
gen C_HighSchool=C_educ==12
gen C_SomeCollege=C_educ>=13 & C_educ<=15
gen C_College=C_educ==16
gen C_PostCollege=C_educ==17
gen C_EducMiss=C_educ>=96

keep C_*  HHID* MPN_* JSUB OPN 

sort HHIDSUB
merge HHIDSUB using parent_long10.dta
tab _merge
drop if _merge==2
drop _merge 

save childdata_all10.dta, replace


use childdata_all10.dta, clear
* Choose population (
disp in red _N
* missing C_age and C_gender
egen maxc=max(C_age==.), by(HHIDSUB)
egen minc=max(C_GENDER==.), by(HHIDSUB)
drop if maxc==1 | minc==1
drop maxc minc 
disp in red _N
* No too young or too old children
egen maxc=max(C_age), by(HHIDSUB)
egen minc=min(C_age), by(HHIDSUB)
gen C_agegaptoE=maxc-C_age
gen C_agegaptoY=C_age-minc
*drop if maxc>65| minc<35
drop if maxc>65 | minc<20
drop maxc minc 
disp in red _N
* missing P_age
egen maxc=max(R_age==.), by(HHIDSUB)
drop if maxc==1 
drop maxc 
disp in red _N
* Min Spouse and R's age is 50
gen SINGLE= S_age==.
gen minc=min(R_age,S_age) if SINGLE==0
drop if minc<50 & SINGLE==0
drop if R_age<50
disp in red _N 
drop minc
* drop if in NH
gen nh2010=R_NURSEHOME==1
replace nh2010=1 if S_NURSEHOME==1
egen maxc=max(nh2010), by(HHIDSUB)
drop if maxc==1 
drop maxc nh2010
disp in red _N
* max child age < min parent age-15
egen maxc=max(C_age), by(HHIDSUB)
gen minc=max(R_age,S_age) if SINGLE==0
replace minc=R_age if SINGLE==1
gen t=minc-maxc
keep if t>15
drop maxc minc t
disp in red _N
* no step children
egen maxc=max(C_stepson+ C_stepdgt), by(HHIDSUB)
drop if maxc==1
drop maxc
disp in red _N
* no same age
bysort HHIDSUB -C_age: gen indage= _n
egen multipleage=max(indage), by(HHIDSUB)
tab multiple
drop if multiple>1
drop multiple
disp in red _N
* LESS THAN 5 CHILDREN
egen TOTCHILD=sum(1), by(HHIDSUB)
keep if TOT<=4
disp in red _N


* create child variables
egen tmax=max(C_age), by(HHIDSUB)
gen C_eldest=tmax==C_age 
egen tmin=min(C_age) , by(HHIDSUB)
gen C_youngest=tmin==C_age 
gen C_onlychild=tmin==tmax & tmin>0 & tmin!=.
drop tmin tmax
replace C_eldest=0 if C_only==1
replace C_youngest=0 if C_only==1

egen count=count(1), by(HHIDSUB)
replace C_only=0 if count>1

label var C_partner "Child married or partnered"
label var C_eldest "Eldest child in multi child; 0 if one child"
label var C_youngest "Youngest child in multi child; 0 if one child"
label var C_only "Only child (eldest=youngest=0)"

* logit dep var
gen Y=0 
replace Y=1 if C_near10==1 | C_cores==1
label def Y 0"Far" 1"Near/Cores" 
label values Y Y

* GENERATING VARIABLES 
recode C_GENDER (2=0), gen(C_male)
label var C_male "C_male"

recode C_partner (5=0)
label var C_partner "C_spouse"
gen C_kids_missing=C_kids>90
replace C_kids_m=1 if C_kids==.
recode C_kids (98/99=0) (.=0)

* sibling structure
gen dage1=0
gen dage2=0
gen dage3=0
gen dage4=0
gen dsex1=0
gen dsex2=0
gen dsex3=0
gen dsex4=0

gsort HHIDSUB -C_age
by HHIDSUB : gen bo=_n
forvalues i=1(1)4 {
gen temp=C_age if bo==`i'
gen temp2=C_male if bo==`i'
egen maxc`i'=max(temp), by(HHIDSUB)
egen sexd`i'=max(temp2), by(HHIDSUB)
replace dage`i'=abs(maxc`i'-C_age)
replace dsex`i'=abs(sexd`i'-C_male)
drop temp*
}

replace dage1=0 if dage1==.
replace dage2=0 if dage2==.
replace dage3=0 if dage3==.
replace dage4=0 if dage4==.
replace dsex1=0 if dsex1==.
replace dsex2=0 if dsex2==.
replace dsex3=0 if dsex3==.
replace dsex4=0 if dsex4==.


gen C_hasyoungerB=0 
gen C_hasyoungerS=0 
 forvalues i=1(1)4 {
replace C_hasyoungerB=1 if maxc`i'<C_age & sexd`i'==1
replace C_hasyoungerS=1 if maxc`i'<C_age & sexd`i'==0
}

gen C_M_hasyounger=0
gen C_F_hasyounger=0
replace C_M_hasyounger=1 if C_male==1 & (C_hasyoungerB==1 | C_hasyoungerS==1)
replace C_F_hasyounger=1 if C_male==0 & (C_hasyoungerB==1 | C_hasyoungerS==1)

gen C_M_youngest=0
gen C_F_youngest=0

by HHIDSUB: replace C_M_youngest=1 if C_male==1 & _n==_N & TOTCHILD>1
by HHIDSUB: replace C_F_youngest=1 if C_male==0 & _n==_N & TOTCHILD>1

gen C_kids_partner=C_kids* C_partner
gen C_kids_single=C_kids*(1-C_partner)

gen C_male_partner=C_male*C_partner
gen C_male_single=C_male*(1-C_partner)
gen C_female_partner=(1-C_male)*C_partner
gen C_female_single = C_male==0 & C_female_partner==0

gen C_age3039= C_age>=30 & C_age<40
gen C_age4049= C_age>=40 & C_age<50
gen C_age50p= C_age>=50

* PARENT VARIABLES
gen P_father=SINGLE==1 & R_GENDER==1
gen P_mother=SINGLE==1 & R_GENDER==2

* parent's age diff
gen P_age = R_age
replace P_age=(R_age+S_age)/2 if SINGLE==0
replace P_age=round(P_age)

gen P_age5064=P_age<=64
gen P_age6579=P_age>=65 & P_age<=79
gen P_age80p=P_age>=80

* both parents beliefs on importance of religion
gen P_religion_very= R_religion_very==1 & SINGLE==1
replace P_religion_very= 1 if R_religion_very==1 & S_religion_very==1 & SINGLE==0

* both parents born in the US
gen P_FOREIGN_BOTH=0
replace P_FOREIGN=1 if R_USBORN!=1 & S_USBORN!=1 & SINGLE==0
replace P_FOREIGN=1 if R_USBORN!=1 & SINGLE==1
* both parents white
gen P_WHITE_BOTH= R_white==1 & S_white==1
replace P_WHITE=1 if R_white==1 & SINGLE==1



* parent health information 
factor R_sah R_ADLall R_IADLsum R_diabetes R_highbp R_stroke
predict R_health

factor S_sah S_ADLall S_IADLsum S_diabetes S_highbp S_stroke if P_father==0 & P_mother==0
predict S_health

gen P_health = -R_health
replace P_health = -(R_health+S_health)/2 if P_father==0 & P_mother==0

* education: ref: at least one parent has High school the other is lower or missing or both missing
gen P_LTHighSchool_both=0
replace P_LTHighSchool_both= R_LTHighSchool if SINGLE==1
replace P_LTHighSchool_both=1 if R_LTHighSchool==1 & S_LTHighSchool==1 & SINGLE==0

gen R_CollegeP=R_College+ R_PostCollege
gen S_CollegeP=S_College+ S_PostCollege

gen P_CollegeP_anyone=0
replace P_CollegeP_anyone= R_CollegeP if SINGLE==1
replace P_CollegeP_anyone=1 if R_CollegeP==1 & S_CollegeP==0 & SINGLE==0
replace P_CollegeP_anyone=1 if R_CollegeP==1 & S_CollegeP==1 & SINGLE==0
replace P_CollegeP_anyone=1 if R_CollegeP==0 & S_CollegeP==1 & SINGLE==0
drop R_CollegeP S_CollegeP

gen S_lower=1 if (SINGLE==0 & S_HighSchool==1) |(SINGLE==0 & S_LTHighSchool==1)
gen R_lower=1 if (SINGLE==0 & R_HighSchool==1) |(SINGLE==0 & R_LTHighSchool==1) | (SINGLE==0 & R_EducMissing==1)
gen P_SomeCollege_anyone=0
replace P_SomeCollege_anyone=R_SomeCollege if SINGLE==1
replace P_SomeCollege_anyone=1 if R_SomeCollege==1 & S_lower==1 & SINGLE==0
replace P_SomeCollege_anyone=1 if R_lower==1 & S_SomeCollege==1 & SINGLE==0
replace P_SomeCollege_anyone=1 if R_SomeCollege==1 & S_SomeCollege==1 & SINGLE==0
drop *_lower

gen R_tempeduc=R_HighSchool + R_EducMi
gen S_tempeduc=S_HighSchool + S_EducMi

gen P_HighSchool_anyone=0
replace P_HighSchool_anyone=R_tempeduc if SINGLE==1
replace P_HighSchool_anyone=1 if R_tempeduc==1 & S_LTHighSchool==1 & SINGLE==0
replace P_HighSchool_anyone=1 if R_LTHighSchool==1 & S_tempeduc==1 & SINGLE==0
replace P_HighSchool_anyone=1 if R_tempeduc==1 & S_tempeduc==1 & SINGLE==0
replace P_HighSchool_anyone=0 if P_SomeCollege
drop *tempeduc


bysort HHIDSUB: gen index=_n

tab TOTCHILD if index==1
gen C_nearcores=0
replace C_nearcores=1 if C_cores==1 | C_near10==1
gen C_far=1-C_nearcores

egen H_near=sum(C_nearcores), by(HHIDSUB)
egen H_far=sum(C_far), by(HHIDSUB)
egen H_neary=sum(C_nearcores*C_youngest), by(HHIDSUB)
egen H_neare=sum(C_nearcores*C_eldest), by(HHIDSUB)

gen final=1

qui tab R_study, gen(P_cohort)
label var P_cohort1 "HRS"
label var P_cohort2 "AHEAD"
label var P_cohort3 "CODA"
label var P_cohort4 "WAR"
label var P_cohort5 "Early BB"
label var P_cohort6 "Late addition"

save childdata_population10.dta, replace














