capture log close
set more off
log using PoolData.log, replace

use childdata_pooled.dta, clear

*** Data Preparation ***
sort HHIDSUB
by HHIDSUB:gen nchild=_N
egen hhid = group (wave HHIDSUB), missing
gsort hhid -C_age

gen C_LEHS=C_HighSchool==1 | C_LTHighSchool==1
gen P_cohab=P_father==0 & P_mother==0


*** Descriptive stats
sum Y P_cohab P_father_ws P_father_nws P_mother_ws P_mother_nws P_age P_WHITE_BOTH P_health P_LTHighSchool_both P_HighSchool P_SomeCollege_anyone P_CollegeP_anyone metro1 metro2 metro3 metro_missing Hownhouse C_age C_male_single C_female_single C_male_partner C_female_partner C_CollegeP C_SomeCollege C_LEHS C_EducMiss C_kids_partner C_kids_single wave1998 wave2004 wave2010


*** Model

global xvar1 P_father_ws P_father_nws P_mother_ws P_mother_nws ///
	P_age P_WHITE_BOTH P_health P_CollegeP_anyone P_SomeCollege_anyone ///
	P_LTHighSchool_both metro2 metro3 metro_missing Hownhouse ///
	C_age C_male_single C_male_partner C_female_partner C_CollegeP ///
	C_SomeCollege C_EducMiss C_kids_partner C_kids_single wave2004 ///
	wave2010
global avar P_father_ws P_father_nws P_mother_ws P_mother_nws /// 
	P_health P_CollegeP_anyone P_SomeCollege_anyone P_LTHighSchool_both C_male ///
	C_CollegeP C_SomeCollege C_EducMiss wave2004 wave2010
global gvar C_age C_male_single C_male_partner C_female_partner
global rvar dage1 dsex1 dage2 dsex2 dage3 dsex3 dage4 dsex4

probit Y $xvar1

outsheet Y hhid $xvar1 $avar $gvar $rvar using data_long.raw, noname comma nolabel replace

outsheet Y hhid $xvar1 using data_short.raw, noname comma nolabel replace


clear 
exit, STATA
