capture log close
set more off
log using PoolDataReverse.log, replace

use childdata_pooled.dta, clear


*** Data Preparation ***
sort HHIDSUB
by HHIDSUB:gen nchild=_N
egen hhid = group (wave HHIDSUB), missing
gsort hhid -C_age

*** Model

global xvar1 P_father_ws P_father_nws P_mother_ws P_mother_nws ///
	P_age P_WHITE_BOTH P_health P_CollegeP_anyone P_SomeCollege_anyone ///
	P_LTHighSchool_both metro2 metro3 metro_missing Hownhouse ///
	C_age C_male_single C_male_partner C_female_partner C_CollegeP ///
	C_SomeCollege C_EducMiss C_kids_partner C_kids_single wave2004 ///
	wave2010
global avar P_father_ws P_father_nws P_mother_ws P_mother_nws /// 
	P_health P_CollegeP_anyone P_SomeCollege_anyone P_LTHighSchool_both C_male ///
	C_CollegeP C_SomeCollege C_EducMiss wave2004 wave2010
global gvar C_age C_male_single C_male_partner C_female_partner
global rvar dage1 dsex1 dage2 dsex2 dage3 dsex3 dage4 dsex4


outsheet Y hhid $xvar1 $avar $gvar $rvar using data_longR.raw, noname comma nolabel replace

outsheet Y hhid $xvar1 using data_shortR.raw, noname comma nolabel replace



clear 
exit, STATA
