SUBROUTINE NESOLVE(near_ne,m,ep,bval,aval,gval)
! This subroutine solves for SPNE outcome: near_cf_s(i)
USE Globvar
IMPLICIT NONE
INTEGER, INTENT(OUT) :: near_ne
INTEGER, INTENT(IN) :: m
REAL(8), INTENT(IN) :: ep(nchild(m))			! ep(1) ... oldest
REAL(8), INTENT(IN) :: bval(nchild(m))			! 1 ... oldest
REAL(8), INTENT(IN) :: aval(nchild(m),3)		! 1 ... oldest
REAL(8), INTENT(IN) :: gval(nchild(m),3)		! 1 ... oldest

INTEGER :: y_ne(nchild(m))						! 1 ... oldest

REAL(8) :: utiltemp1, utiltemp0    ! utility if near and far
INTEGER :: s1, s2, s3, s4  ! s1 ... oldest child's strategy
REAL(8) :: utils2(0:1),utils3(0:3),utils4(0:7)
INTEGER :: i,j,k


SELECT CASE(nchild(m))

CASE(1)

utiltemp1=bval(1)+aval(1,1)+ep(1)
IF (utiltemp1>0.0) THEN
    y_ne(1)=1
ELSE
    y_ne(1)=0
END IF
	near_ne=y_ne(1)

CASE(2)

! 2nd child
s2=0 ; utils2=0.0d0
! upstream=0
utiltemp1=bval(2)+aval(2,1)+ep(2)
IF (utiltemp1>0.0) THEN
    s2=s2+1
    utils2(0)=utiltemp1
END IF
! upstream=1
utiltemp1=bval(2)+aval(2,2)+gval(2,1)+ep(2)
utiltemp0=aval(2,1)
IF (utiltemp1>utiltemp0) THEN
    s2=s2+2
    utils2(1)=utiltemp1
ELSE
    utils2(1)=utiltemp0
END IF

! 1st child
utiltemp1=bval(1) &
	+IBITS(s2,1,1)*(aval(1,2)+gval(1,1)) &
	+(1-IBITS(s2,1,1))*aval(1,1) &
	+ep(1)
utiltemp0=IBITS(s2,0,1)*aval(1,1)
IF (utiltemp1>utiltemp0) THEN
    y_ne(1)=1
    y_ne(2)=IBITS(s2,1,1)
ELSE
    y_ne(1)=0
    y_ne(2)=IBITS(s2,0,1)
END IF

near_ne=y_ne(1)*2+y_ne(2)


CASE(3)

! 3rd child
s3=0 ; utils3=0.0d0
! upstream=0
utiltemp1=bval(3)+aval(3,1)+ep(3)
utiltemp0=0.0d0
IF (utiltemp1>utiltemp0) THEN
    s3=s3+1
    utils3(0)=utiltemp1
END IF
! upstream=1
utiltemp1=bval(3)+aval(3,2)+gval(3,1)+ep(3)
utiltemp0=aval(3,1)
IF (utiltemp1>utiltemp0) THEN
    s3=s3+2
    utils3(1)=utiltemp1
ELSE
    utils3(1)=utiltemp0
END IF
! upstream=2
utiltemp1=bval(3)+aval(3,3)+gval(3,2)+ep(3)
utiltemp0=aval(3,2)
IF (utiltemp1>utiltemp0) THEN
    s3=s3+4
    utils3(2)=utiltemp1
ELSE
    utils3(2)=utiltemp0
END IF

! 2nd child
s2=0 ; utils2=0.0d0
! upstream=0
utiltemp1=bval(2) &
	+ IBITS(s3,1,1)*(aval(2,2)+gval(2,1)) &
	+ (1-IBITS(s3,1,1))*aval(2,1) &
	+ ep(2)
utiltemp0=IBITS(s3,0,1)*aval(2,1)
IF (utiltemp1>utiltemp0) THEN
    s2=s2+1
    utils2(0)=utiltemp1
ELSE
    utils2(0)=utiltemp0
END IF
! upstream=1
utiltemp1=bval(2) &
	+ IBITS(s3,2,1)*(aval(2,3)+gval(2,2)) &
	+ (1-IBITS(s3,2,1))*(aval(2,2)+gval(2,1)) &
	+ ep(2)
utiltemp0 = IBITS(s3,1,1)*aval(2,2) + (1-IBITS(s3,1,1))*aval(2,1)

IF (utiltemp1>utiltemp0) THEN
    s2=s2+2
    utils2(1)=utiltemp1
ELSE
    utils2(1)=utiltemp0
END IF

! 1st child
utiltemp1=bval(1) & 
	+ IBITS(s2,1,1)*IBITS(s3,2,1)*(aval(1,3)+gval(1,2)) &
	+ IBITS(s2,1,1)*(1-IBITS(s3,2,1))*(aval(1,2)+gval(1,1)) &
	+ (1-IBITS(s2,1,1))*IBITS(s3,1,1)*(aval(1,2)+gval(1,1)) &
	+ (1-IBITS(s2,1,1))*(1-IBITS(s3,1,1))*aval(1,1) &
	+ ep(1)
utiltemp0= &
	+ IBITS(s2,0,1)*IBITS(s3,1,1)*aval(1,2) &
	+ IBITS(s2,0,1)*(1-IBITS(s3,1,1))*aval(1,1) &
	+ (1-IBITS(s2,0,1))*IBITS(s3,0,1)*aval(1,1)

IF (utiltemp1>utiltemp0) THEN
    y_ne(1)=1
    y_ne(2)=IBITS(s2,1,1)
    y_ne(3)=IBITS(s2,1,1)*IBITS(s3,2,1)+(1-IBITS(s2,1,1))*IBITS(s3,1,1)
ELSE
    y_ne(1)=0
    y_ne(2)=IBITS(s2,0,1)
    y_ne(3)=IBITS(s2,0,1)*IBITS(s3,1,1)+(1-IBITS(s2,0,1))*IBITS(s3,0,1)
END IF

near_ne=y_ne(1)*4+y_ne(2)*2+y_ne(3)


CASE(4)

! 4th child
s4=0 ; utils4=0.0d0
! upstream=0
utiltemp1=bval(4)+aval(4,1)+ep(4)
utiltemp0=0.0d0
IF (utiltemp1>utiltemp0) THEN
    s4=s4+1
    utils4(0)=utiltemp1
END IF
! upstream=1
utiltemp1=bval(4)+aval(4,2)+gval(4,1)+ep(4)
utiltemp0=aval(4,1)
IF (utiltemp1>utiltemp0) THEN
    s4=s4+2
    utils4(1)=utiltemp1
ELSE
    utils4(1)=utiltemp0
END IF
! upstream=2
utiltemp1=bval(4)+aval(4,3)+gval(4,2)+ep(4)
utiltemp0=aval(4,2)
IF (utiltemp1>utiltemp0) THEN
    s4=s4+4
    utils4(2)=utiltemp1
ELSE
    utils4(2)=utiltemp0
END IF
! upstream=3
utiltemp1=bval(4)+aval(4,3)+gval(4,3)+ep(4)
utiltemp0=aval(4,3)
IF (utiltemp1>utiltemp0) THEN
    s4=s4+8
    utils4(3)=utiltemp1
ELSE
    utils4(3)=utiltemp0
END IF

! 3rd child
s3=0 ; utils3=0.0d0
! upstream=0
utiltemp1=bval(3) &
	+ IBITS(s4,1,1)*(aval(3,2)+gval(3,1)) &
	+ (1-IBITS(s4,1,1))*aval(3,1) &
	+ ep(3)
utiltemp0=IBITS(s4,0,1)*aval(3,1)
IF (utiltemp1>utiltemp0) THEN
    s3=s3+1
    utils3(0)=utiltemp1
ELSE
    utils3(0)=utiltemp0
END IF
! upstream=1
utiltemp1=bval(3) &
	+ IBITS(s4,2,1)*(aval(3,3)+gval(3,2)) &
	+ (1-IBITS(s4,2,1))*(aval(3,2)+gval(3,1)) &
	+ ep(3)
utiltemp0= IBITS(s4,1,1)*aval(3,2) + (1-IBITS(s4,1,1))*aval(3,1)
IF (utiltemp1>utiltemp0) THEN
    s3=s3+2
    utils3(1)=utiltemp1
ELSE
    utils3(1)=utiltemp0
END IF
! upstream=2
utiltemp1 = bval(3)+aval(3,3)+IBITS(s4,3,1)*gval(3,3)+(1-IBITS(s4,3,1))*gval(3,2)+ep(3)
utiltemp0 = IBITS(s4,2,1)*aval(3,3) + (1-IBITS(s4,2,1))*aval(3,2)

IF (utiltemp1>utiltemp0) THEN
    s3=s3+4
    utils3(2)=utiltemp1
ELSE
    utils3(2)=utiltemp0
END IF

! 2nd child
s2=0 ; utils2=0.0d0
! upstream=0
utiltemp1=bval(2) &
	+ IBITS(s3,1,1)*IBITS(s4,2,1)*(aval(2,3)+gval(2,2)) &
	+ IBITS(s3,1,1)*(1-IBITS(s4,2,1))*(aval(2,2)+gval(2,1)) &
	+ (1-IBITS(s3,1,1))*IBITS(s4,1,1)*(aval(2,2)+gval(2,1)) &
	+ (1-IBITS(s3,1,1))*(1-IBITS(s4,1,1))*aval(2,1) &
	+ ep(2)
utiltemp0= &
	+ IBITS(s3,0,1)*IBITS(s4,1,1)*aval(2,2) &
	+ IBITS(s3,0,1)*(1-IBITS(s4,1,1))*aval(2,1) &
	+ (1-IBITS(s3,0,1))*IBITS(s4,0,1)*aval(2,1)
IF (utiltemp1>utiltemp0) THEN
    s2=s2+1
    utils2(0)=utiltemp1
ELSE
    utils2(0)=utiltemp0
END IF
! upstream=1
utiltemp1=bval(2) &
	+ IBITS(s3,2,1)*IBITS(s4,3,1)*(aval(2,3)+gval(2,3)) &
	+ IBITS(s3,2,1)*(1-IBITS(s4,3,1))*(aval(2,3)+gval(2,2)) &
	+ (1-IBITS(s3,2,1))*IBITS(s4,2,1)*(aval(2,3)+gval(2,2)) &
	+ (1-IBITS(s3,2,1))*(1-IBITS(s4,2,1))*(aval(2,2)+gval(2,1)) &
	+ ep(2)
utiltemp0= &
	+ IBITS(s3,1,1)*IBITS(s4,2,1)*aval(2,3) &
	+ IBITS(s3,1,1)*(1-IBITS(s4,2,1))*aval(2,2) &
	+ (1-IBITS(s3,1,1))*IBITS(s4,1,1)*aval(2,2) &
	+ (1-IBITS(s3,1,1))*(1-IBITS(s4,1,1))*aval(2,1)
IF (utiltemp1>utiltemp0) THEN
    s2=s2+2
    utils2(1)=utiltemp1
ELSE
    utils2(1)=utiltemp0
END IF

! 1st child
utiltemp1=bval(1) & 
	+ IBITS(s2,1,1)*IBITS(s3,2,1)*IBITS(s4,3,1)*(aval(1,3)+gval(1,3)) &
	+ IBITS(s2,1,1)*IBITS(s3,2,1)*(1-IBITS(s4,3,1))*(aval(1,3)+gval(1,2)) &
	+ IBITS(s2,1,1)*(1-IBITS(s3,2,1))*IBITS(s4,2,1)*(aval(1,3)+gval(1,2)) &
	+ IBITS(s2,1,1)*(1-IBITS(s3,2,1))*(1-IBITS(s4,2,1))*(aval(1,2)+gval(1,1)) &
	+ (1-IBITS(s2,1,1))*IBITS(s3,1,1)*IBITS(s4,2,1)*(aval(1,3)+gval(1,2)) &
	+ (1-IBITS(s2,1,1))*IBITS(s3,1,1)*(1-IBITS(s4,2,1))*(aval(1,2)+gval(1,1)) &
	+ (1-IBITS(s2,1,1))*(1-IBITS(s3,1,1))*IBITS(s4,1,1)*(aval(1,2)+gval(1,1)) &
	+ (1-IBITS(s2,1,1))*(1-IBITS(s3,1,1))*(1-IBITS(s4,1,1))*aval(1,1) &
	+ ep(1)
utiltemp0= &
	+ IBITS(s2,0,1)*IBITS(s3,1,1)*IBITS(s4,2,1)*aval(1,3) &
	+ IBITS(s2,0,1)*IBITS(s3,1,1)*(1-IBITS(s4,2,1))*aval(1,2) &
	+ IBITS(s2,0,1)*(1-IBITS(s3,1,1))*IBITS(s4,1,1)*aval(1,2) &
	+ IBITS(s2,0,1)*(1-IBITS(s3,1,1))*(1-IBITS(s4,1,1))*aval(1,1) &
	+ (1-IBITS(s2,0,1))*IBITS(s3,0,1)*IBITS(s4,1,1)*aval(1,2) &
	+ (1-IBITS(s2,0,1))*IBITS(s3,0,1)*(1-IBITS(s4,1,1))*aval(1,1) &
	+ (1-IBITS(s2,0,1))*(1-IBITS(s3,0,1))*IBITS(s4,0,1)*aval(1,1)

IF (utiltemp1>utiltemp0) THEN
    y_ne(1)=1
    y_ne(2)=IBITS(s2,1,1)
    y_ne(3)=IBITS(s2,1,1)*IBITS(s3,2,1)+(1-IBITS(s2,1,1))*IBITS(s3,1,1)
    y_ne(4)=IBITS(s2,1,1)*(IBITS(s3,2,1)*IBITS(s4,3,1)+(1-IBITS(s3,2,1))*IBITS(s4,2,1)) &
           +(1-IBITS(s2,1,1))*(IBITS(s3,1,1)*IBITS(s4,2,1)+(1-IBITS(s3,1,1))*IBITS(s4,1,1))

ELSE
    y_ne(1)=0
    y_ne(2)=IBITS(s2,0,1)
    y_ne(3)=IBITS(s2,0,1)*IBITS(s3,1,1)+(1-IBITS(s2,0,1))*IBITS(s3,0,1)
    y_ne(4)=IBITS(s2,0,1)*(IBITS(s3,1,1)*IBITS(s4,2,1)+(1-IBITS(s3,1,1))*IBITS(s4,1,1)) &
           +(1-IBITS(s2,0,1))*(IBITS(s3,0,1)*IBITS(s4,1,1)+(1-IBITS(s3,0,1))*IBITS(s4,0,1))
END IF

near_ne=y_ne(1)*8+y_ne(2)*4+y_ne(3)*2+y_ne(4)

CASE DEFAULT
    PRINT *,'nchild(m): ', nchild(m)
    PRINT *,'error'
    PAUSE
END SELECT


END SUBROUTINE NESOLVE